Live Bing Organic SERP HTML

Live SERP HTML provides a raw HTML page of search engine results for the specified keyword, search engine, and location.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live SERP API call can contain only one task.

Below you will find a detailed description of the parameters that are required or recommended for setting a task.
 
Main Parameters

Field nameTypeDescription
keywordstring

keyword

required field

you can specify up to 700 characters in the keyword field

all %## will be decoded (plus character '+' will be decoded to a space character)

if you need to use the "%" character for your keyword, please specify it as "%25";

if you need to use the “+” character for your keyword, please specify it as “%2B”;


learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

location_codeinteger

search engine location code

required field if you don't specify location_name or location_coordinate

if you use this field, you don't need to specify location_name or location_coordinate

you can receive the list of available locations of the search engines with their location_code by making a separate request to the https://api.dataforseo.com/v3/serp/bing/locations

example:

2840

language_codestring

search engine language code

required field if you don't specify language_name

if you use this field, you don't need to specify language_name

you can receive the list of available languages of the search engine with their language_code by making a separate request to the https://api.dataforseo.com/v3/serp/bing/languages

example:

en

depthinteger

parsing depth

optional field

number of results in SERP

default value: 10

max value: 200


Your account will be billed per each SERP containing up to 10 results;

Setting depth above 10 may result in additional charges if the search engine returns more than 10 results;

The cost can be calculated on the Pricing page.

devicestring

device type

optional field

return results for a specific device type

can take the values:desktop, mobile

default value: desktop


Below you will find a drop-down list with the additional parameters you can use for setting a task.
Additional Parameters
Field nameTypeDescription
location_namestring

full name of search engine location

required field if you don't specify location_code or location_coordinate

if you use this field, you don't need to specify location_code or location_coordinate

you can receive the list of available locations of the search engine with their location_name by making a separate request to the https://api.dataforseo.com/v3/serp/bing/locations

example:

London,England,United Kingdom

language_namestring

full name of search engine language

required field if you don't specify language_code

if you use this field, you don't need to specify language_code

you can receive the list of available languages of the search engine with their language_name by making a separate request to the https://api.dataforseo.com/v3/serp/bing/languages

example:

English

osstring

device operating system

optional field

if you specify desktop in the device field, choose from the following values: windows, macos

default value: windows

if you specify mobile in the device field, choose from the following values: android, ios

default value: android

tagstring

user-defined task identifier

optional field

the character limit is 255

you can use this parameter to identify the task and match it with the result

you will find the specified tag value in the data object of the response

stop_crawl_on_matcharray

array of targets to stop crawling

optional field

specified as an array of target objects

each target object consists of one match_type field and one match_value field

you can specify up to 10 target objects in this array

if specified, the response will contain SERP results up to and including the specified match_value;

example:

"stop_crawl_on_match":[{"match_value":"dataforseo.com","match_type":"with_subdomains"}]

learn more about this parameter on our Help Center


Your account will be billed for every SERP crawled until the conditions you specified in this array are met
match_typestring

target match type

required field if stop_crawl_on_match is specified

type of match for the match_value

possible values:

domain – specific domain or subdomain

with_subdomains – main domain and subdomains

wildcard – wildcard pattern

match_valuestring

target domain, subdomain, or wildcard value

required field if stop_crawl_on_match is specified

specify a target domain, subdomain, or wildcard value;

Note: domain or subdomain must be specified without a request protocol;

example: "match_value": "dataforseo.com",

"match_value": "/blog/post-*"

max_crawl_pagesinteger

page crawl limit

optional field

number of search results pages to crawl

default value: 1

max value: 100

Note: the max_crawl_pages and depth parameters complement each other;

learn more at our help center

search_paramstring

additional parameters of the search query

optional field

get the list of available parameters and additional details here

urlstring

direct URL of the search query

optional field

you can specify a direct URL and we will sort it out to the necessary fields. Note that this method is the most difficult for our API to process and also requires you to specify the exact language and location in the URL. In most cases, we wouldn’t recommend using this method.

example:

https://www.bing.com/search?q=rank%20checker&count=50&first=1&setlang=en&cc=US&safesearch=Moderate&FORM=SEPAGE

location_coordinatestring

GPS coordinates of a location

required field if you don't specify location_name or location_code

if you use this field, you don't need to specify location_name or location_code

location_coordinate parameter should be specified in the "latitude,longitude" format

the maximum number of decimal digits for "latitude" and "longitude": 7

example:

53.476225,-2.243572


‌‌‌‌‌‌‌‌‌‌‌‌‌‌‌‌‌
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword received in a POST array
keyword is returned with decoded %## (plus character '+' will be decoded to a space character)

        typestring

search engine type in a POST array

        se_domainstring

search engine domain in a POST array

        location_codeinteger

location code in a POST array

        language_codestring

language code in a POST array

        datetimestring

date and time when the result was received
in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”
example:
2019-11-15 12:57:46 +00:00

        items_countinteger

the number of results returned in the items array

        itemsarray

elements of search results found in SERP

            pageinteger

serial number of the returned HTML page

            datestring

date and time when the HTML page was scanned
in the format: “year-month-date:minutes:UTC_difference_hours:UTC_difference_minutes”
example:
2019-11-15 12:57:46 +00:00

            htmlstring

HTML page


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/serp/bing/organic/live/html" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "language_code": "en",
        "location_code": 2840,
        "keyword": "albert einstein"
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// You can set only one task at a time
$post_array[] = array(
	"language_code" => "en",
	"location_code" => 2840,
	"keyword" => mb_convert_encoding("albert einstein", "UTF-8")
);
try {
	// POST /v3/serp/bing/organic/live/html
	// in addition to 'bing' and 'organic' you can also set other search engine and type parameters
	// the full list of possible parameters is available in documentation
	$result = $client->post('/v3/serp/bing/organic/live/html', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const axios = require('axios');

axios({
    method: 'post',
    url: 'https://api.dataforseo.com/v3/serp/bing/local_pack/live/html',
    auth: {
        username: 'login',
        password: 'password'
    },
    data: [{
        "keyword": encodeURI("albert einstein"),
        "language_code": "en",
        "location_code": 2840
    }],
    headers: {
        'content-type': 'application/json'
    }
}).then(function (response) {
    var result = response['data']['tasks'];
    // Result data
    console.log(result);
}).catch(function (error) {
    console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# You can set only one task at a time
post_data[len(post_data)] = dict(
    language_code="en",
    location_code=2840,
    keyword="albert einstein"
)
# POST /v3/serp/bing/organic/live/html
# the full list of possible parameters is available in documentation
response = client.post("/v3/serp/bing/organic/live/html", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task serp_live_html()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                //DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // You can set only one task at a time
            postData.Add(new
            {
                language_code = "en",
                location_code = 2840,
                keyword = "albert einstein"
            });
            // POST /v3/serp/bing/organic/live/html
            // in addition to 'bing' and 'organic' you can also set other search engine and type parameters
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/serp/bing/organic/live/html", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20200203",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "4.7397 sec.",
  "cost": 0.003,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "02041503-1535-0140-0000-7bf8119e5832",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "4.6696 sec.",
      "cost": 0.003,
      "result_count": 1,
      "path": [
        "v3",
        "serp",
        "bing",
        "organic",
        "live",
        "html"
      ],
      "data": {
        "api": "serp",
        "function": "live",
        "se": "bing",
        "se_type": "organic",
        "language_code": "en",
        "location_code": "2840",
        "keyword": "albert einstein",
        "tag": "tag1",
        "device": "desktop",
        "os": "windows"
      },
      "result": [
        {
          "keyword": "albert einstein",
          "type": "organic",
          "se_domain": "bing.com",
          "location_code": 2840,
          "language_code": "en",
          "datetime": "2020-02-04 13:04:02 +0000",
          "items_count": 1,
          "items": [
            {
              "page": 1,
              "date": "2020-02-04 13:04:02 +0000",
              "html": "<!doctype html><html><head></head></body></html>"
            }
          ]
        }
      ]
    }
  ]
}